# Functions for parsing command-line options
#
# Copyright (C) 2013, 2015  Patrick McDermott
#
# This file is part of the ProteanOS Development Kit.
#
# The ProteanOS Development Kit is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# The ProteanOS Development Kit is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the ProteanOS Development Kit.  If not, see
# <http://www.gnu.org/licenses/>.

get_options()
{
	local optstring=
	local prefix=
	local opt=

	if [ "x${running_cmd_clean}" = 'x' ]; then
		optstring="${OPTSTRING}"
		prefix='opt_'
	else
		eval "optstring=\"\${cmd_${running_cmd_clean}_optstring}\""
		prefix="cmd_${running_cmd_clean}_opt_"
	fi

	unset OPTARG
	while getopts "${optstring}" opt; do
		if [ "x${opt}" = 'x?' ]; then
			return 1
		fi
		case "${optstring}" in
			*"${opt}:"*)
				eval "${prefix}${opt}=\"\${OPTARG}\""
				;;
			*)
				eval "${prefix}${opt}=true"
				;;
		esac
		unset OPTARG
	done

	return 0
}
